package com.genpt.nsight.v4.service.impl;

import com.google.common.util.concurrent.ThreadFactoryBuilder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.concurrent.*;

@Configuration
@EnableAsync
public class AsyncConfiguration {
    @Value("${inventory.verificationThreads}")
    private int asyncThreads;

    @Bean(name = "asyncExecutor")
    public Executor asyncExecutor() {
        return new ThreadPoolExecutor(5, asyncThreads, 10, TimeUnit.SECONDS,
                new LinkedBlockingQueue<>(asyncThreads*50),
                new ThreadFactoryBuilder().setNameFormat("InventoryVerificationPublisher-thread-%d").build(),
                (r, executor) -> { throw new RejectedExecutionException("InventoryVerificationPublisher rejected from queue");});
    }

}