package com.genpt.nsight.v4.service.impl;

import com.google.common.util.concurrent.ThreadFactoryBuilder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;

import java.util.concurrent.*;

@Configuration
@EnableAsync
public class AsyncDeliveryConfiguration
{
    @Value("${delivery.publisherThreads}")
    private int asyncThreads;

    @Bean(name = "asyncDeliveryExecutor")
    public Executor asyncDeliveryExecutor() {
        return new ThreadPoolExecutor(5, asyncThreads, 10, TimeUnit.SECONDS,
                new LinkedBlockingQueue<>(asyncThreads*50),
                new ThreadFactoryBuilder().setNameFormat("AsyncDeliveryPublisher-thread-%d").build(),
                (r, executor) -> { throw new RejectedExecutionException("AsyncDeliveryPublisher rejected from queue");});
    }
}